# Generated by the gRPC Python protocol compiler plugin. DO NOT EDIT!
"""Client and server classes corresponding to protobuf-defined services."""
import grpc

from google.protobuf import empty_pb2 as google_dot_protobuf_dot_empty__pb2
import protos_generated.projector_pb2 as projector__pb2


class ProjectorStub(object):
    """Interface exported by the server.
    """

    def __init__(self, channel):
        """Constructor.

        Args:
            channel: A grpc.Channel.
        """
        self.Start = channel.unary_unary(
            '/provee.Projector/Start',
            request_serializer=google_dot_protobuf_dot_empty__pb2.Empty.SerializeToString,
            response_deserializer=google_dot_protobuf_dot_empty__pb2.Empty.FromString,
        )
        self.Stop = channel.unary_unary(
            '/provee.Projector/Stop',
            request_serializer=google_dot_protobuf_dot_empty__pb2.Empty.SerializeToString,
            response_deserializer=google_dot_protobuf_dot_empty__pb2.Empty.FromString,
        )
        self.GetProjectionPoints = channel.unary_stream(
            '/provee.Projector/GetProjectionPoints',
            request_serializer=projector__pb2.TrainingSet.SerializeToString,
            response_deserializer=projector__pb2.Point.FromString,
        )
        self.GetUpdates = channel.unary_stream(
            '/provee.Projector/GetUpdates',
            request_serializer=google_dot_protobuf_dot_empty__pb2.Empty.SerializeToString,
            response_deserializer=projector__pb2.Point.FromString,
        )


class ProjectorServicer(object):
    """Interface exported by the server.
    """

    def Start(self, request, context):
        """A simple RPC.

        Start the Projector calculation
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def Stop(self, request, context):
        """Stop the Projector calculation
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def GetProjectionPoints(self, request, context):
        """A server-to-client streaming RPC.

        Obtains the Projection Points in 2D given the trainings values stored in a row format.  Results are
        streamed rather than returned at once (e.g. in a response message with a
        repeated field).
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def GetUpdates(self, request, context):
        """A server-to-client streaming RPC.

        Obtains the Projection Points in 2D given the trainings values stored in a row format.  Results are
        streamed rather than returned at once (e.g. in a response message with a
        repeated field).
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')


def add_ProjectorServicer_to_server(servicer, server):
    rpc_method_handlers = {
        'Start': grpc.unary_unary_rpc_method_handler(
            servicer.Start,
            request_deserializer=google_dot_protobuf_dot_empty__pb2.Empty.FromString,
            response_serializer=google_dot_protobuf_dot_empty__pb2.Empty.SerializeToString,
        ),
        'Stop': grpc.unary_unary_rpc_method_handler(
            servicer.Stop,
            request_deserializer=google_dot_protobuf_dot_empty__pb2.Empty.FromString,
            response_serializer=google_dot_protobuf_dot_empty__pb2.Empty.SerializeToString,
        ),
        'GetProjectionPoints': grpc.unary_stream_rpc_method_handler(
            servicer.GetProjectionPoints,
            request_deserializer=projector__pb2.TrainingSet.FromString,
            response_serializer=projector__pb2.Point.SerializeToString,
        ),
        'GetUpdates': grpc.unary_stream_rpc_method_handler(
            servicer.GetUpdates,
            request_deserializer=google_dot_protobuf_dot_empty__pb2.Empty.FromString,
            response_serializer=projector__pb2.Point.SerializeToString,
        ),
    }
    generic_handler = grpc.method_handlers_generic_handler(
        'provee.Projector', rpc_method_handlers)
    server.add_generic_rpc_handlers((generic_handler,))

 # This class is part of an EXPERIMENTAL API.


class Projector(object):
    """Interface exported by the server.
    """

    @staticmethod
    def Start(request,
              target,
              options=(),
              channel_credentials=None,
              call_credentials=None,
              insecure=False,
              compression=None,
              wait_for_ready=None,
              timeout=None,
              metadata=None):
        return grpc.experimental.unary_unary(request, target, '/provee.Projector/Start',
                                             google_dot_protobuf_dot_empty__pb2.Empty.SerializeToString,
                                             google_dot_protobuf_dot_empty__pb2.Empty.FromString,
                                             options, channel_credentials,
                                             insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def Stop(request,
             target,
             options=(),
             channel_credentials=None,
             call_credentials=None,
             insecure=False,
             compression=None,
             wait_for_ready=None,
             timeout=None,
             metadata=None):
        return grpc.experimental.unary_unary(request, target, '/provee.Projector/Stop',
                                             google_dot_protobuf_dot_empty__pb2.Empty.SerializeToString,
                                             google_dot_protobuf_dot_empty__pb2.Empty.FromString,
                                             options, channel_credentials,
                                             insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def GetProjectionPoints(request,
                            target,
                            options=(),
                            channel_credentials=None,
                            call_credentials=None,
                            insecure=False,
                            compression=None,
                            wait_for_ready=None,
                            timeout=None,
                            metadata=None):
        return grpc.experimental.unary_stream(request, target, '/provee.Projector/GetProjectionPoints',
                                              projector__pb2.TrainingSet.SerializeToString,
                                              projector__pb2.Point.FromString,
                                              options, channel_credentials,
                                              insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def GetUpdates(request,
                   target,
                   options=(),
                   channel_credentials=None,
                   call_credentials=None,
                   insecure=False,
                   compression=None,
                   wait_for_ready=None,
                   timeout=None,
                   metadata=None):
        return grpc.experimental.unary_stream(request, target, '/provee.Projector/GetUpdates',
                                              google_dot_protobuf_dot_empty__pb2.Empty.SerializeToString,
                                              projector__pb2.Point.FromString,
                                              options, channel_credentials,
                                              insecure, call_credentials, compression, wait_for_ready, timeout, metadata)
